<!--*ngIf="setVisible(crudRequest)" necessary to ignore initial (or reset after request has been handle) undefined values-->
<!--Add or Update operation; 3 == CRUDType.DELETE-->
<div id="crud-container" *ngIf="setVisible(crudRequest)">
  <form *ngIf="crudRequest && crudRequest.method !== 3; else deleteOp;"
        class="crud-option" [formGroup]="formGroup" (ngSubmit)="onSaveClicked()">
    <div class="input-wrapper">
      <ng-container *ngFor="let attr of ['name', 'description', 'price', 'size']">
        <label [for]="attr">{{attr}}</label>

        <input type="text" [id]="attr" [formControlName]="attr">
      </ng-container>

      <!-- origin attribute-->
      <label for="origin">Origin</label>
      <select id="origin" name="origin" formControlName="origin">
        <option value="" selected disabled hidden>Select an option</option>

        <ng-container *ngFor="let origin of originArr">
          <option [value]="origin">{{origin}}</option>
        </ng-container>
      </select>
    </div>

    <div class="submit-wrapper">
      <!--Short-circuits to the template-->
      <ng-container *ngIf="false; else cancelTemplate"></ng-container>

      <button type="submit" [disabled]="!formGroup.valid">SAVE</button>
    </div>

    <ul id="err-feedback-container" *ngIf="!formGroup.valid || isInvalidUpdate">
      <!--  TODO ====================== Refactor section for DRY when Directive Test added ======================-->
      <!--Don't show err msg if user hasn't entered an input-->
      <li *ngIf="hasValErr('name')" class="err-feedback"><p>{{apiMetrics.NAME_MSG}}</p></li>

      <li *ngIf="hasValErr('description')" class="err-feedback"><p>{{apiMetrics.DESC_MSG}}</p></li>

      <li *ngIf="hasValErr('price')" class="err-feedback"><p>{{apiMetrics.PRICE_MSG}}</p></li>

      <li *ngIf="hasValErr('size')" class="err-feedback"><p>{{apiMetrics.SIZE_MSG}}</p></li>

      <!--With the impl <select> an error occurred is not as a result of user, hence redundant-->
      <!--<p *ngIf="hasValErr('origin')" class="invalid">{{apiMetrics.ORIGIN_MSG}}</p>-->

      <li *ngIf="isInvalidUpdate" class="err-feedback"><p>Nothing to Update: no changes to existing product.</p></li>
    </ul>
  </form>

  <!--Delete operation-->
  <ng-template #deleteOp>
    <div class="crud-option">
      <p>Are you sure you want to delete <strong>{{getProductAttr('name')}}?</strong></p>

      <div class="submit-wrapper">
        <!--Short-circuits to the template-->
        <ng-container *ngIf="false; else cancelTemplate"></ng-container>

        <button type="button" (click)="onDeleteClicked()">DELETE</button>
      </div>
    </div>
  </ng-template>
</div>

<!--Use with ng-container to promote DRY-->
<ng-template #cancelTemplate>
  <span class="spacer"></span>
  <button id="cancel-btn" type="button" (click)="onCancelClicked()">CANCEL</button>
</ng-template>
